#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <adminmenu>

public Plugin:myinfo = 
{
	name = "AWP NoZoom",
	author = "NoTiCE",
	description = "AWP NoZoom",
	version = "1.0",
	url = "http://www.novgames.ru/"
};

new Handle:g_hEnable = INVALID_HANDLE;
new Handle:g_hAdminMenu = INVALID_HANDLE;

public OnPluginStart()
{
	g_hEnable = CreateConVar("sm_awp_nozoom", "0", "Enable/disable awp no zoom", _, true, 0.0, true, 1.0);
	
	AutoExecConfig(true, "awp_nozoom");
	
	HookEvent("weapon_zoom", Event_WeaponZoom, EventHookMode_Pre);
	
	new Handle:topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != INVALID_HANDLE))
		OnAdminMenuReady(topmenu);
}

public OnAdminMenuReady(Handle:topmenu)
{
	if (topmenu == g_hAdminMenu)
		return;
	
	g_hAdminMenu = topmenu;
	
	new TopMenuObject:server_commands = FindTopMenuCategory(g_hAdminMenu, ADMINMENU_SERVERCOMMANDS);
	
	if(server_commands != INVALID_TOPMENUOBJECT)
		AddToTopMenu(g_hAdminMenu, "sm_togglezoom", TopMenuObject_Item, ItemToggleZoom, server_commands, "sm_togglezoom", ADMFLAG_GENERIC);
}

public ItemToggleZoom(Handle:topmenu, TopMenuAction:action, TopMenuObject:object_id, client, String:buffer[], maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%s", GetConVarBool(g_hEnable) ? "Выключить AWP NoZoom" : "Включить AWP NoZoom");
	else if (action == TopMenuAction_SelectOption)
	{
		SetConVarBool(g_hEnable, GetConVarBool(g_hEnable) ? false : true);
		DisplayTopMenu(g_hAdminMenu, client, TopMenuPosition_LastCategory);
	}
}

public Action:Event_WeaponZoom(Handle:event,const String:name[],bool:dontBroadcast)
{
	if(GetConVarBool(g_hEnable))
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		decl String:weaponname[32];
		GetClientWeapon(client, weaponname, sizeof(weaponname));
		if (StrEqual(weaponname, "weapon_awp", false))
		{
			new weapon = GetPlayerWeaponSlot(client, CS_SLOT_PRIMARY);
			if (IsValidEdict(weapon))
			{
				RemovePlayerItem(client, weapon);
				RemoveEdict(weapon);
				CreateTimer(0.1, Timer_GiveAWP, client, TIMER_FLAG_NO_MAPCHANGE);
			}
		}
	}
	
	return Plugin_Continue;
}

public Action:Timer_GiveAWP(Handle:timer, any:client)
{
	if(IsClientInGame(client) && IsPlayerAlive(client))
		GivePlayerItem(client, "weapon_awp");
	
	return Plugin_Stop;
}